package com.gic.evaluate.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.evaluate.constant.Constants;
import com.gic.evaluate.constant.ReplyerTypeEnum;
import com.gic.evaluate.dao.mapper.TabProblemReplyMapper;
import com.gic.evaluate.dto.ProblemMemberReplyDTO;
import com.gic.evaluate.dto.ProblemReplyDTO;
import com.gic.evaluate.dto.ProblemUserReplyDTO;
import com.gic.evaluate.entity.TabProblemReply;
import com.gic.evaluate.service.ProblemReplyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 11:37
 */
@Service
public class ProblemReplyServiceImpl implements ProblemReplyService {

    @Autowired
    private TabProblemReplyMapper tabProblemReplyMapper;

    @Override
    public List<TabProblemReply> listReply(Integer problemId) {
        return tabProblemReplyMapper.listReply(problemId);
    }

    @Override
    public void save(ProblemUserReplyDTO problemUserReplyDTO) {
        TabProblemReply tabProblemReply = new TabProblemReply();
        tabProblemReply.setEnterpriseId(problemUserReplyDTO.getEnterpriseId());
        tabProblemReply.setProblemId(problemUserReplyDTO.getProblemId());
        tabProblemReply.setReplyerType(ReplyerTypeEnum.USER.getCode());
        tabProblemReply.setReplyContent(problemUserReplyDTO.getReplyContent());
        tabProblemReply.setUserId(problemUserReplyDTO.getUserId());
        tabProblemReply.setUserName(problemUserReplyDTO.getUserName());
        tabProblemReply.setStatus(Constants.OPEN);
        tabProblemReply.setCreateTime(new Date());
        tabProblemReplyMapper.insertSelective(tabProblemReply);
    }

    @Override
    public int save(ProblemMemberReplyDTO problemMemberReplyDTO) {
        TabProblemReply problemReply = new TabProblemReply();
        problemReply.setEnterpriseId(problemMemberReplyDTO.getEnterpriseId());
        problemReply.setProblemId(problemMemberReplyDTO.getProblemId());
        problemReply.setReplyerType(ReplyerTypeEnum.MEMBER.getCode());
        problemReply.setReplyContent(problemMemberReplyDTO.getReplyContent());
        problemReply.setMemberId(problemMemberReplyDTO.getMemberId());
        problemReply.setMemberName(problemMemberReplyDTO.getMemberName());
        problemReply.setStatus(Constants.OPEN);
        problemReply.setCreateTime(new Date());
        return tabProblemReplyMapper.insertSelective(problemReply);
    }

    @Override
    public void update(ProblemReplyDTO problemReplyDTO) {
        TabProblemReply tabProblemReply = EntityUtil.changeEntityByJSON(TabProblemReply.class, problemReplyDTO);
        tabProblemReplyMapper.insertSelective(tabProblemReply);
    }
}
