package com.gic.evaluate.service.outer.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.response.EnterpriseServiceResponse;
import com.gic.evaluate.constant.Constants;
import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.dto.ProblemMemberReplyDTO;
import com.gic.evaluate.service.ProblemHaobanApiService;
import com.gic.evaluate.service.ProblemImgService;
import com.gic.evaluate.service.ProblemReplyService;
import com.gic.evaluate.service.ProblemService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 14:31
 */
@Service("problemHaobanApiService")
public class ProblemHaobanApiServiceImpl implements ProblemHaobanApiService {

    @Autowired
    private ProblemService problemService;
    @Autowired
    private ProblemReplyService problemReplyService;
    @Autowired
    private ProblemImgService problemImgService;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ServiceResponse<Void> saveProblem(ProblemDTO problemDTO) {
        List<String> imgUrlList = problemDTO.getImgUrlList();
        if (CollectionUtils.isNotEmpty(imgUrlList)) {
            problemDTO.setImageUrl(imgUrlList.get(0));
            problemDTO.setHasOtherImage(imgUrlList.size() > 1 ? Constants.OPEN : Constants.CLOSE);
        }
        Integer problemId = problemService.save(problemDTO);
        if (CollectionUtils.isNotEmpty(imgUrlList)) {
            problemImgService.saveList(problemDTO.getEnterpriseId(), problemId, imgUrlList);
        }
        return EnterpriseServiceResponse.success();
    }

    @Override
    public ServiceResponse<Void> saveProblemReply(ProblemMemberReplyDTO problemMemberReplyDTO) {
        List<String> imgUrlList = problemMemberReplyDTO.getImgUrlList();
        Integer problemReplyId = problemReplyService.save(problemMemberReplyDTO);
        if (CollectionUtils.isNotEmpty(imgUrlList)) {
            problemImgService.saveList(problemMemberReplyDTO.getEnterpriseId(), problemMemberReplyDTO.getProblemId(), problemReplyId, imgUrlList);
        }
        return EnterpriseServiceResponse.success();
    }
}